-- Birdcage mod version 1.2
-- by _Q_
if GetModConfigData("Feather Drop Time") == "rarer" then
	TUNING.FEATHER_DROP_TIME = 10 * TUNING.TOTAL_DAY_TIME
end

if GetModConfigData("Feather Drop Time") == "rare" then
	TUNING.FEATHER_DROP_TIME = TUNING.TOTAL_DAY_TIME
end

if GetModConfigData("Feather Drop Time") == "less" then
	TUNING.FEATHER_DROP_TIME = 0.7 * TUNING.TOTAL_DAY_TIME
end

if GetModConfigData("Feather Drop Time") == "default" then
	TUNING.FEATHER_DROP_TIME = 0.5 * TUNING.TOTAL_DAY_TIME
end

if GetModConfigData("Feather Drop Time") == "more" then
	TUNING.FEATHER_DROP_TIME = 0.3 * TUNING.TOTAL_DAY_TIME
end

if GetModConfigData("Feather Drop Time") == "often" then
	TUNING.FEATHER_DROP_TIME = 0.2 * TUNING.TOTAL_DAY_TIME
end

if GetModConfigData("Feathers On Ground Limit") == "rare" then
	TUNING.FEATHERS_ON_GROUND = 2
end

if GetModConfigData("Feathers On Ground Limit") == "less" then
	TUNING.FEATHERS_ON_GROUND = 4
end

if GetModConfigData("Feathers On Ground Limit") == "default" then
	TUNING.FEATHERS_ON_GROUND = 6
end

if GetModConfigData("Feathers On Ground Limit") == "more" then
	TUNING.FEATHERS_ON_GROUND = 8
end

if GetModConfigData("Feathers On Ground Limit") == "often" then
	TUNING.FEATHERS_ON_GROUND = 10
end

if GetModConfigData("Amount Of Named Seeds") == "less" then
	TUNING.SEEDS_AMOUNT_LOWER = 1
	TUNING.SEEDS_AMOUNT_UPPER = 1
end

if GetModConfigData("Amount Of Named Seeds") == "default" then
	TUNING.SEEDS_AMOUNT_LOWER = 1
	TUNING.SEEDS_AMOUNT_UPPER = 2
end

if GetModConfigData("Amount Of Named Seeds") == "more" then
	TUNING.SEEDS_AMOUNT_LOWER = 2
	TUNING.SEEDS_AMOUNT_UPPER = 3
end

if GetModConfigData("Amount Of Named Seeds") == "often" then
	TUNING.SEEDS_AMOUNT_LOWER = 2
	TUNING.SEEDS_AMOUNT_UPPER = 4
end

local CAGE_STATES =
{
    DEAD = "_death",
    SKELETON = "_skeleton",
    EMPTY = "_empty",
    FULL = "_bird",
}

local function SetBirdType(inst, bird)
    inst.bird_type = bird
    inst.AnimState:AddOverrideBuild(inst.bird_type.."_build")
end

local function SetCageState(inst, state)
    inst.CAGE_STATE = state
end

local function GetCageState(inst)
    return inst.CAGE_STATE
end

local function GetBird(inst)
    return (inst.components.occupiable and inst.components.occupiable:GetOccupant()) or nil
end

local function GetHunger(bird)
    return (bird and bird.components.perishable and bird.components.perishable:GetPercent()) or 1
end

local function DigestFoodMod(inst, food)
    if food.components.edible.foodtype == GLOBAL.FOODTYPE.MEAT then
        inst.components.lootdropper:SpawnLootPrefab("bird_egg")
    else
        local seed_name = string.lower(food.prefab .. "_seeds")
        if GLOBAL.Prefabs[seed_name] ~= nil then
            local num_seeds = math.random(TUNING.SEEDS_AMOUNT_LOWER, TUNING.SEEDS_AMOUNT_UPPER)
            for k = 1, num_seeds do
                inst.components.lootdropper:SpawnLootPrefab(seed_name)
            end
            if math.random() < 0.5 then
                inst.components.lootdropper:SpawnLootPrefab("seeds")
            end
        else
            if math.random() < 0.33 then
                local loot = inst.components.lootdropper:SpawnLootPrefab("guano")
                loot.Transform:SetScale(.33, .33, .33)
            end
        end
	end
    local bird = GetBird(inst)
    if bird and bird:IsValid() and bird.components.perishable then
        bird.components.perishable:SetPercent(1)
    end
end

local function OnGetItemMod(inst, giver, item)
    if inst.components.sleeper and inst.components.sleeper:IsAsleep() then
        inst.components.sleeper:WakeUp()
    end

    if item.components.edible ~= nil and
        (   item.components.edible.foodtype == GLOBAL.FOODTYPE.MEAT
            or item.prefab == "seeds"
            or GLOBAL.Prefabs[string.lower(item.prefab .. "_seeds")] ~= nil
        ) then
        inst.AnimState:PlayAnimation("peck")
        inst.AnimState:PushAnimation("peck")
        inst.AnimState:PushAnimation("peck")
        inst.AnimState:PushAnimation("hop")
        inst:PlayStateAnim("idle", true)
        inst:DoTaskInTime(60 * GLOBAL.FRAMES, DigestFoodMod, item)
    end
end

function find_bird(var1)

local bird_names =
   {
     "robin_winter",
     "crow",
     "robin",
   }
   
       for i=1,3 do
       local var2 = string.match (var1, bird_names[i])
			if var2 ~= nil then
			return var2
			end
       end
 end

local function ShouldSleep(inst)
    local bird = GetBird(inst)
    return GLOBAL.TheWorld.state.isnight and GetHunger(bird) >= 0.33
end

local function ShouldWake(inst)
    local bird = GetBird(inst)
    return GLOBAL.TheWorld.state.isday or GetHunger(bird) < 0.33
end

local function DoAnimationTask(inst)
    local bird = GetBird(inst)
    local hunger = GetHunger(bird)
    local rand = math.random()

    if hunger < 0.33 then
        if rand < 0.75 then
            inst.AnimState:PlayAnimation("idle_bird3")

            inst:DoTaskInTime(5 * GLOBAL.FRAMES, function() inst.SoundEmitter:PlaySound("dontstarve/birds/wingflap_cage") end)
            inst:DoTaskInTime(15 * GLOBAL.FRAMES, function() inst.SoundEmitter:PlaySound("dontstarve/birds/wingflap_cage") end)
            inst:DoTaskInTime(28 * GLOBAL.FRAMES, function() inst.SoundEmitter:PlaySound("dontstarve/birds/wingflap_cage") end)

            inst:DoTaskInTime(4 * GLOBAL.FRAMES, function() inst.SoundEmitter:PlaySound(bird.sounds.chirp) end)
            inst:DoTaskInTime(27 * GLOBAL.FRAMES, function() inst.SoundEmitter:PlaySound(bird.sounds.chirp) end)
            inst:DoTaskInTime(42 * GLOBAL.FRAMES, function() inst.SoundEmitter:PlaySound(bird.sounds.chirp) end)
            inst:DoTaskInTime(100 * GLOBAL.FRAMES, function() inst.SoundEmitter:PlaySound(bird.sounds.chirp) end)
        end
    elseif hunger < 0.66 then
        if rand < 0.5 then

            inst:DoTaskInTime(26 * GLOBAL.FRAMES, function() inst.SoundEmitter:PlaySound(bird.sounds.chirp) end)
            inst:DoTaskInTime(81 * GLOBAL.FRAMES, function() inst.SoundEmitter:PlaySound(bird.sounds.chirp) end)
            inst:DoTaskInTime(96 * GLOBAL.FRAMES, function() inst.SoundEmitter:PlaySound(bird.sounds.chirp) end)
        end
    else
        if rand < 0.5 then
            inst.AnimState:PlayAnimation("caw")
            if inst.chirpsound then
                inst.SoundEmitter:PlaySound(inst.chirpsound)
            end
        elseif rand < 0.6 then
            inst.AnimState:PlayAnimation("flap")
            inst.SoundEmitter:PlaySound("dontstarve/birds/wingflap_cage")
        else
            inst.AnimState:PlayAnimation("hop")
        end
	end
    inst:PlayStateAnim("idle", true)	
end
local function StartAnimationTask(inst)
    inst.AnimationTask = inst:DoPeriodicTask(6, DoAnimationTask)
end

local function StopAnimationTask(inst)
    if inst.AnimationTask then
        inst.AnimationTask:Cancel()
        inst.AnimationTask = nil
    end
end

local function OnOccupied(inst, bird)
    SetCageState(inst, CAGE_STATES.FULL)
	
	inst:AddComponent("feathers")
	local var = tostring(inst.components.occupiable.occupant)
	local nam = find_bird(var)
	inst.components.feathers.birdname = nam
	
    inst:AddComponent("sleeper")
    inst.components.sleeper:SetSleepTest(ShouldSleep)
    inst.components.sleeper:SetWakeTest(ShouldWake)

    inst.components.trader:Enable()

    SetBirdType(inst, bird.prefab)

    inst.chirpsound = bird.sounds and bird.sounds.chirp
    inst.AnimState:PlayAnimation("flap")
    inst.SoundEmitter:PlaySound("dontstarve/birds/wingflap_cage")
    inst:PlayStateAnim("idle", true)

    StartAnimationTask(inst)
end

local function OnEmptied(inst, bird)
	inst.components.feathers.birdname = nil
	inst:RemoveComponent("feathers")
	
    SetCageState(inst, CAGE_STATES.EMPTY)

    inst:RemoveComponent("sleeper")

    inst.components.trader:Disable()

    inst:PlayStateAnim("idle")

    StopAnimationTask(inst)
end

local function OnBirdStarve(inst, bird)
	if inst.components.feathers then
		inst.components.feathers.birdname = nil
		inst:RemoveComponent("feathers")
	end
	
    SetCageState(inst, CAGE_STATES.DEAD)
    
    inst.AnimState:PlayAnimation("death")
    inst:PlayStateAnim("idle", true)

    local loot = GLOBAL.SpawnPrefab("smallmeat")
    inst.components.inventory:GiveItem(loot)
    inst.components.shelf:PutItemOnShelf(loot)
end

function birdcagePrefabPostInit(inst)
	
	if inst and inst.components.trader then
	inst.components.trader.onaccept = OnGetItemMod
	end
	
	if inst and inst.components.occupiable then
	inst.components.occupiable.onoccupied = OnOccupied
	inst.components.occupiable.onperishfn = OnBirdStarve
	end
	
	if inst and inst.components.occupiable then
	inst.components.occupiable.onemptied = OnEmptied
	end
	
end

AddPrefabPostInit("birdcage", birdcagePrefabPostInit)

function featherPrefabPostInit(inst)
	if not inst:HasTag("feather") then
		inst:AddTag("feather")
	end
end

AddPrefabPostInit("feather_crow", featherPrefabPostInit)
AddPrefabPostInit("feather_robin", featherPrefabPostInit)
AddPrefabPostInit("feather_robin_winter", featherPrefabPostInit)
